#!/usr/bin/perl -w
# psp.pl <file_name>
# load iTunes' library and play party shuffle
# wrote by cheekcat<cheekcat@cheekcat.ath.cx> http://cheekcat.ath.cx/
# version 0.1

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use strict;
use Encode qw/from_to/;

#---configure Start
my $prefix="file://localhost/C:";
my $mount_on="/mnt/win";
my $encode_to="euc-jp";
my $shuffle_rule="011222333344444555555";
#my $shuffle_rule="5";
my $mpg123="/usr/bin/mpg123";
#---configure End

# prefix:iTunesΥ饤֥ΥեؤΥեѥǺʬ
#        WindowsǤiTunesǡCɥ饤֤˲ڤ֤Ƥ "file://localhost/C:" ˤʤޤ
# mount_on:prefixʬǺʬɤ֤뤫줾Υɥ饤֤Υޥꤷޤ
# encode_to:ե륷ƥǻȤƤʸɤꤷޤ
# shuffle_rule:ƥ졼Ȥκ٤ꤷޤ줾οʸ줾Υ졼Ȥκ٤ˤʤޤ
#              shuffle_rule="45" ȤiPodΥȥåץ졼ȤΤ褦˺ޤ
# mpg123:ڥե뤿ΥޥɤؤΥѥꤷޤ

my @sdata=([],[],[],[],[],[]);

#check arg
my $file=shift;
die "Usage:pshuffle.pl <iTunes' Library file name>" if($file eq "");

#check if file is exist
die "file not exist" unless(-f $file);
die "permission denied" unless(-r $file);

open IN,"< $file";

#file pattern check
while(<DATA>){
    chomp;
    last if(/^End_Of_Data$/);
    die "File:$file is not valid iTunes' Library" unless(<IN> =~ /^$_[\r\n]*$/);
}
print "File match\n";

my $lastrate;
while(<IN>){
    $lastrate=0 if(/<dict>/);
    $lastrate=$1 if(/<key>Rating<\/key><integer>([0-9]*)<\/integer>/);
    if(/<key>Location<\/key><string>([^<]*)<\/string>/){
	my $temp=$1;
	$temp =~ s/^$prefix/$mount_on/;
	$temp =~ s/\/$//;
	$temp =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack('H2', $1)/eg;
	from_to($temp,"utf-8",$encode_to);

	push(@{$sdata[$lastrate/20]},$temp);
    }
}
close IN;

#my $i=0;
#foreach my $ref(@sdata){
#    print "Rate $i\n";
#    $i++;
#    foreach my $dat(@$ref){
#	print $dat,"\n";
#    }
#}

srand();
for(;;){
    my $num=int(substr($shuffle_rule,rand(length($shuffle_rule)),1));
    my $song=$sdata[$num][int(rand(@{$sdata[$num]}))];
    print "Rate $num - $song start playing...\n";
    `$mpg123 '$song'`;
}


__DATA__
<\?xml version="1.0" encoding\="UTF-8"\?>
<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
End_Of_Data
